//---------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#pragma hdrstop

#include "CapFilter.h"
#include "AddressSet.h"
#include "ProtocolSelect.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TCapFilterDlg *CapFilterDlg;
//---------------------------------------------------------------------
__fastcall TCapFilterDlg::TCapFilterDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------------
void __fastcall TCapFilterDlg::FormCreate(TObject *Sender)
{
	TabControl->TabIndex = 0;
}
//---------------------------------------------------------------------
void __fastcall TCapFilterDlg::ButtonAddClick(TObject *Sender)
{
	switch (TabControl->TabIndex)
	{
	case MAC_PAGE:
	case IPA_PAGE:
		Application->CreateForm(__classid(TAddressInputDlg), &AddressInputDlg);
		AddressInputDlg->InitDlg((TabControl->TabIndex == IPA_PAGE) ? true : false);
		if (AddressInputDlg->ShowModal() == mrOk)
		{
			IFilterParam* pParam;
			CoCreateInstance(CLSID_FilterParam, NULL, CLSCTX_INPROC_SERVER, IID_IFilterParam, (void**)&pParam);
			AnsiString s(AddressInputDlg->GetResult());
			VARIANT v;
			VariantInit(&v);
			v.vt = VT_BSTR;
			v.bstrVal = StringToOleStr(s);
			pParam->set_Value(v);
			VariantClear(&v);
			switch (AddressInputDlg->GetDirection())
			{
			case TAddressInputDlg::DT_SRC:
				s = "M:" + s;
				pParam->set_Source(VARIANT_TRUE);
				break;
			case TAddressInputDlg::DT_DST:
				s = "Đ:" + s;
				pParam->set_Destination(VARIANT_TRUE);
				break;
			default:
				s = "o:" + s;
				pParam->set_Source(VARIANT_TRUE);
				pParam->set_Destination(VARIANT_TRUE);
				break;
			}
			int idx;
			ListBox->Items->Add(s);

			if (TabControl->TabIndex == IPA_PAGE)
			{
				pParam->set_Type(FT_IPADDRESS);
				idx = IPAddrList->Add(s);
				IPAddrList->Objects[idx] = (TObject*)pParam;
			}
			else
			{
				pParam->set_Type(FT_MACADDRESS);
				idx = MacList->Add(s);
				MacList->Objects[idx] = (TObject*)pParam;
			}
		}
		delete AddressInputDlg;
		break;
	default:
		Application->CreateForm(__classid(TProtocolSelectDlg), &ProtocolSelectDlg);
		if (ProtocolSelectDlg->ShowModal() == mrOk)
		{
			AnsiString s(ProtocolSelectDlg->GetResultString());
			if (ListBox->Items->IndexOf(s) < 0)
			{
				IFilterParam* pParam;
				CoCreateInstance(CLSID_FilterParam, NULL, CLSCTX_INPROC_SERVER, IID_IFilterParam, (void**)&pParam);
				VARIANT v;
				VariantInit(&v);
				v.vt = VT_I2;
				v.iVal = ProtocolSelectDlg->GetResult();
				pParam->set_Value(v);
				VariantClear(&v);
				pParam->set_Type(FT_PROTOCOL);
				ListBox->Items->Add(s);
				int idx = ProtList->Add(s);
				ProtList->Objects[idx] = (TObject*)pParam;
			}
		}
		delete ProtocolSelectDlg;
		break;
	}
}
//---------------------------------------------------------------------------

void __fastcall TCapFilterDlg::TabControlChange(TObject *Sender)
{
	switch (TabControl->TabIndex)
	{
	case MAC_PAGE:
		ListBox->Items = MacList;
		ButtonEdit->Enabled = true;
		break;
	case IPA_PAGE:
		ListBox->Items = IPAddrList;
		ButtonEdit->Enabled = true;
		break;
	default:
		ListBox->Items = ProtList;
		ButtonEdit->Enabled = false;
		break;
	}
}
//---------------------------------------------------------------------------


void __fastcall TCapFilterDlg::ButtonDeleteClick(TObject *Sender)
{
	int idx = ListBox->ItemIndex;
	if (idx >= 0 && idx < ListBox->Items->Count)
	{
		ListBox->Items->Delete(idx);
		TStringList* pList;
		switch (TabControl->TabIndex)
		{
		case MAC_PAGE:
			pList = MacList;
			break;
		case IPA_PAGE:
			pList = IPAddrList;
			break;
		default:
			pList = ProtList;
			break;
		}
		((IUnknown*)pList->Objects[idx])->Release();
		pList->Delete(idx);
	}
}
//---------------------------------------------------------------------------

void __fastcall TCapFilterDlg::ButtonEditClick(TObject *Sender)
{
	int idx = ListBox->ItemIndex;
	TAddressInputDlg::DirectionType dt = TAddressInputDlg::DT_BI;
	if (idx >= 0 && idx < ListBox->Items->Count)
	{
		AnsiString s = ListBox->Items->Strings[idx];
		TStringList* pList;
		bool IP;

		switch (TabControl->TabIndex)
		{
		case MAC_PAGE:
		case IPA_PAGE:
			Application->CreateForm(__classid(TAddressInputDlg), &AddressInputDlg);
			if (TabControl->TabIndex == IPA_PAGE)
			{
				pList = IPAddrList;
				IP = true;
			}
			else
			{
				pList = MacList;
				IP = false;
			}
			AddressInputDlg->InitDlg(IP);
			if (s.AnsiPos("") == 1)
			{
				dt = TAddressInputDlg::DT_SRC;
			}
			else if (s.AnsiPos("") == 1)
			{
				dt = TAddressInputDlg::DT_DST;
			}
			s = s.c_str() + 7;
			AddressInputDlg->SetDefault(dt, s);

			if (AddressInputDlg->ShowModal() == mrOk)
			{
				s = AddressInputDlg->GetResult();
				IFilterParam* pParam = (IFilterParam*)pList->Objects[idx];
				VARIANT v;
				VariantInit(&v);
				v.vt = VT_BSTR;
				v.bstrVal = StringToOleStr(s);
				pParam->set_Value(v);
				VariantClear(&v);
				switch (AddressInputDlg->GetDirection())
				{
				case TAddressInputDlg::DT_SRC:
					s = "M:" + s;
					pParam->set_Source(VARIANT_TRUE);
					pParam->set_Destination(VARIANT_FALSE);
					break;
				case TAddressInputDlg::DT_DST:
					s = "Đ:" + s;
					pParam->set_Source(VARIANT_FALSE);
					pParam->set_Destination(VARIANT_TRUE);
					break;
				default:
					s = "o:" + s;
					pParam->set_Source(VARIANT_TRUE);
					pParam->set_Destination(VARIANT_TRUE);
					break;
				}
				ListBox->Items->Strings[idx] = s;
				pList->Objects[idx] = (TObject*)pParam;
			}
			delete AddressInputDlg;
			break;
		default:
			break;
		}
	}
}
//---------------------------------------------------------------------------

