//---------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <vcl\sysutils.hpp>
#include <vcl\windows.hpp>
#include <vcl\messages.hpp>
#include <vcl\sysutils.hpp>
#include <vcl\classes.hpp>
#include <vcl\graphics.hpp>
#include <vcl\controls.hpp>
#include <vcl\forms.hpp>
#include <vcl\dialogs.hpp>
#include <vcl\stdctrls.hpp>
#include <vcl\buttons.hpp>
#include <vcl\extctrls.hpp>
#include <vcl\menus.hpp>
#include <Buttons.hpp>
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>

#include "MACCAPLib_TLB.h"
#include <Grids.hpp>
#include <StdCtrls.hpp>

#ifndef COUNTOF
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
#endif
//---------------------------------------------------------------------------

class TMainForm;
	interface DMacCaptureEvent : public IDispatch
	{
	public:
		DMacCaptureEvent() : RefCount(1)
		{
		}
		HRESULT STDMETHODCALLTYPE QueryInterface(
			/* [in] */ REFIID riid,
			/* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject)
		{
			if (IsEqualIID(DIID__IMacCaptureEvents, riid)
				|| IsEqualIID(IID_IUnknown, riid) || IsEqualIID(IID_IDispatch, riid))
			{
				++RefCount;
				*ppvObject = this;
				return S_OK;
			}
			return E_NOINTERFACE;
		}

		ULONG STDMETHODCALLTYPE AddRef()
		{
			return ++RefCount;
		}
		ULONG STDMETHODCALLTYPE Release()
		{
			return --RefCount;	// not release here.
		}
		HRESULT STDMETHODCALLTYPE GetTypeInfoCount(
			/* [out] */ UINT __RPC_FAR *pctinfo)
		{
			return E_NOTIMPL;
		}
		HRESULT STDMETHODCALLTYPE GetTypeInfo(
			/* [in] */ UINT iTInfo,
			/* [in] */ LCID lcid,
			/* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo)
		{
			return E_NOTIMPL;
		}
		HRESULT STDMETHODCALLTYPE GetIDsOfNames(
			/* [in] */ REFIID riid,
			/* [size_is][in] */ LPOLESTR __RPC_FAR *rgszNames,
			/* [in] */ UINT cNames,
			/* [in] */ LCID lcid,
			/* [size_is][out] */ DISPID __RPC_FAR *rgDispId)
		{
			return E_NOTIMPL;
		}
		HRESULT STDMETHODCALLTYPE Invoke(
			/* [in] */ DISPID dispIdMember,
			/* [in] */ REFIID riid,
			/* [in] */ LCID lcid,
			/* [in] */ WORD wFlags,
			/* [out][in] */ DISPPARAMS __RPC_FAR *pDispParams,
			/* [out] */ VARIANT __RPC_FAR *pVarResult,
			/* [out] */ EXCEPINFO __RPC_FAR *pExcepInfo,
			/* [out] */ UINT __RPC_FAR *puArgErr);
		TMainForm* Parent;
	private:
		ULONG RefCount;
};

class TMainForm : public TForm
{
        friend DMacCaptureEvent;
__published:
	TMainMenu *MainMenu;
	TMenuItem *FileNewItem;
	TMenuItem *FileOpenItem;
	TMenuItem *FileSaveAsItem;
	TMenuItem *FilePrintItem;
	TMenuItem *FilePrintSetupItem;
	TMenuItem *FileExitItem;
	TMenuItem *EditCopyItem;
	TMenuItem *HelpContentsItem;
	TMenuItem *HelpSearchItem;
	TMenuItem *HelpAboutItem;
	TStatusBar *StatusLine;
	TOpenDialog *OpenDialog;
	TSaveDialog *SaveDialog;
	TPrintDialog *PrintDialog;
	TPrinterSetupDialog *PrintSetupDialog;
	TPanel *SpeedBar;
	TSpeedButton *SpeedButton1;  // VK쐬(&N)
	TSpeedButton *OpenButton;
	TSpeedButton *SaveButton;
	TSpeedButton *CopyButton;
	TSpeedButton *AboutButton;
	TTreeView *TreeView;
	TSplitter *Splitter1;
	TPanel *Panel1;
	TSplitter *Splitter2;
	TListView *ListView;
	TMenuItem *Show1;
	TMenuItem *DispTreeItem;
	TMenuItem *DispListItem;
	TMenuItem *N2;
	TMenuItem *FullExpandItem;
	TMenuItem *EtherTypeExpandItem;
	TMenuItem *FullCollapseItem;
	TMenuItem *N5;
	TMenuItem *OptionSetItem;
	TRichEdit *DumpView;
	TSpeedButton *PrintButton;
	TSpeedButton *ListUpButton;
	TSpeedButton *ListDownButton;
	TSpeedButton *SyncButton;
	TFontDialog *FontDialog;
	TMenuItem *N6;
	TMenuItem *Font1;
	TSpeedButton *FontButton;
	TSpeedButton *ExpandButton;
	TSpeedButton *CollapseButton;
	TMenuItem *Color1;
	void __fastcall ShowHint(TObject *Sender);
	void __fastcall FileNew(TObject *Sender);
	void __fastcall FileOpen(TObject *Sender);
	void __fastcall FileSaveAs(TObject *Sender);
	void __fastcall FilePrint(TObject *Sender);
	void __fastcall FilePrintSetup(TObject *Sender);
	void __fastcall FileExit(TObject *Sender);
	void __fastcall EditCopy(TObject *Sender);
	void __fastcall HelpContents(TObject *Sender);
	void __fastcall HelpSearch(TObject *Sender);
	void __fastcall HelpAbout(TObject *Sender);
	void __fastcall OnIdle(TObject* Sender, bool& Done);
	
	void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
	void __fastcall TreeViewEnter(TObject *Sender);

	void __fastcall DispTreeItemClick(TObject *Sender);
	void __fastcall DispListItemClick(TObject *Sender);
	void __fastcall FullExpandItemClick(TObject *Sender);
	void __fastcall EtherTypeExpandItemClick(TObject *Sender);
	void __fastcall ListViewEnter(TObject *Sender);
	void __fastcall ListViewChange(TObject *Sender, TListItem *Item,
		  TItemChange Change);
	void __fastcall SpeedBarResize(TObject *Sender);

	void __fastcall FullCollapseItemClick(TObject *Sender);
	void __fastcall OptionSetItemClick(TObject *Sender);
	
	void __fastcall DumpViewChange(TObject *Sender);
	
	void __fastcall StatusLineResize(TObject *Sender);
	
	void __fastcall ListUpButtonClick(TObject *Sender);
	
	void __fastcall ListDownButtonClick(TObject *Sender);
	void __fastcall SyncButtonClick(TObject *Sender);
	void __fastcall Font1Click(TObject *Sender);
	void __fastcall FontDialogApply(TObject *Sender, HWND Wnd);
	
	void __fastcall Color1Click(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:        // private [U[錾
	IMacCapture* MacCapture;
	bool Capturing;
	bool AsyncMode;
	bool NoUpdate;
	long Ticks;
	int TicksCount;
	long ATicks[20];
	int Packets;
	int Bytes;
	long ParamInterval;
	long ParamBuffSize;
	int DumpWidth;
	int ListLastSelected;
	TTreeNode* TreeLastSelected;
	DWORD dwCookie;
	TWinControl* LastFocused;
	TList* ListPacket;
	TStringList* MacList;
	TStringList* IPAddrList;
	TStringList* ProtList;
	TStringList* DumpList;
	DMacCaptureEvent* CaptureEventRecver;
public:         // public [U[錾
	enum {
		MAC_HLEN = 14,
		//
		ET_RARP = 0x8035,
		//
		SL_MAC = 3,
		SL_NIC = 2,
		SL_STAT = 1,
	};
	virtual __fastcall TMainForm(TComponent* Owner);
	//
	inline IMacCapture* GetMacCap() { return MacCapture; }
	void StopEvent(long);
	void MonitorEvent(long, long, long, VARIANT_BOOL*);
	//
	void SetIndex(char* pFileName = "NewCapture");
	void InitNew();
	void ClearList();
	//
	void PrintFile(TTreeNode*, IMacPacket*, SAFEARRAY*);
	void PrintFileInfo(TTreeNode*);
	void PrintMACInfo(IMacPacket*, SAFEARRAY*);
	//
	void PrintPacketLevel(IMacPacket*, SAFEARRAY*);
	void PrintIPHeader(LPBYTE, IMacPacket*);
	void PrintARP(LPBYTE, IMacPacket*);
	//
	void PrintIPLevel(IMacPacket*, SAFEARRAY*, int&rest, LPBYTE& pb);
	const char* GetServiceName(short port, bool tcp);
	//
	LPCSTR GetICMPTypeName(BYTE b);
	AnsiString GetUDPInfo(LPBYTE pb);
	AnsiString GetTCPInfo(LPBYTE pb);
	AnsiString GetOSPFInfo(LPBYTE pb);
	//
	int PrintICMP(TStrings*, LPBYTE pb, int len);
	int PrintUDP(TStrings*, LPBYTE, int);
	int PrintTCP(TStrings*, LPBYTE, int);
	int PrintOSPF(TStrings*, LPBYTE, int);
	//
	void DumpData(LPBYTE, int, int);
	void ChangeFT(__int64&, SYSTEMTIME&);
	// window operation
	void SetVisible(TMenuItem*, TControl*);
	void DispCurrentPacketIndex(int, bool Reading = false);
	//
	void MoveList(bool Up);
	void MoveTree(bool Up, TTreeNode*);
	void ChangeMoveButtons(bool);
	void ChangeDumpButtons(bool);
	void ChangeExpandButtons(bool);
        __fastcall ~TMainForm();
	//
	enum {
		COLOR_DUMP,
		COLOR_MACH,
		COLOR_PROTO,
		COLOR_IP,
		//
		COLOR_MAX,
	};
private:
	TColor Color[COLOR_MAX];
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
