// Copyright(c) 1999 arton

// MacMonitor.h : Declaration of the CMacMonitor

#ifndef __MACMONITOR_H_
#define __MACMONITOR_H_

#include "resource.h"
#include "NCap.h"
#include "MacCapCP.h"
#include "Filter.h"

class CAdapters;
/////////////////////////////////////////////////////////////////////////////
// CMacMonitor
class ATL_NO_VTABLE CMacMonitor : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CMacMonitor, IMacMonitor, &IID_IMacMonitor, &LIBID_MACCAPV2Lib>,
	public CComControl<CMacMonitor>,
	public IPersistStreamInitImpl<CMacMonitor>,
#if 0
	public IPerPropertyBrowsingImpl<CMacMonitor>,
#endif
	public IOleControlImpl<CMacMonitor>,
	public IOleObjectImpl<CMacMonitor>,
	public IOleInPlaceActiveObjectImpl<CMacMonitor>,
	public IViewObjectExImpl<CMacMonitor>,
	public IOleInPlaceObjectWindowlessImpl<CMacMonitor>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CMacMonitor>,
	public IProvideClassInfo2Impl<&CLSID_MacMonitor, &DIID__IMacCaptureEvents, &LIBID_MACCAPV2Lib, MACCAPLIB_MJ>,
	public CComCoClass<CMacMonitor, &CLSID_MacMonitor>,
	public CProxy_IMacCaptureEvents< CMacMonitor >
{
public:
	CMacMonitor()
		: m_lMonitorEventInterval(1000), m_pAdapters(NULL), m_bValid(FALSE), m_bEnabled(TRUE),
		  m_idThread(0), m_hThread(NULL), m_hThreadSync(NULL), m_fMonitoring(false)
	{
		m_fLoading = false;
		m_fDuringCapture = m_fRecvDataEnabled = false;
		CStockPropImpl<CMacMonitor, IMacMonitor, &IID_IMacMonitor, &LIBID_MACCAPV2Lib>::_tih.m_wMajor = MACCAPLIB_MJ;
		CStockPropImpl<CMacMonitor, IMacMonitor, &IID_IMacMonitor, &LIBID_MACCAPV2Lib>::_tih.m_wMinor = 0;

		m_bAutoSize = m_bDrawFromNatural = m_bWindowOnly = TRUE;
		m_bResizeNatural = FALSE;

		HDC hDC = ::GetDC(NULL);
		int cxPPI = GetDeviceCaps(hDC, LOGPIXELSX);
		int cyPPI = GetDeviceCaps(hDC, LOGPIXELSY);

		m_sizeExtent.cx = (long)MulDiv(2540, GetSystemMetrics(SM_CXICON), cxPPI);
		m_sizeExtent.cy = (long)MulDiv(2540, GetSystemMetrics(SM_CYICON), cyPPI);
		m_sizeNatural = m_sizeExtent;

		::ReleaseDC(NULL, hDC); 

		m_uiStartMonitor = ::RegisterWindowMessage(_T("MACCAP_MONITOR_START"));
		m_uiStopMonitor = ::RegisterWindowMessage(_T("MACCAP_MONITOR_STOP"));
		m_uiFreeBuffer = ::RegisterWindowMessage(_T("MACCAP_MONITOR_FREE"));
		m_uiReadBuffer = ::RegisterWindowMessage(_T("MACCAP_MONITOR_READ"));
		m_uiFireNext = ::RegisterWindowMessage(_T("MACCAP_MONITOR_FIRENEXT"));
	}

	enum {
		MAX_IO = 16,
		BUFF_SIZE = 2000,
		//
		ID_TMR = 1,
	};

	HRESULT FinalConstruct();
	void FinalRelease();

DECLARE_REGISTRY_RESOURCEID(IDR_MACMONITOR)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMacMonitor)
	COM_INTERFACE_ENTRY(IMacMonitor)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
#if 0
	COM_INTERFACE_ENTRY(IPerPropertyBrowsing)
#endif
END_COM_MAP()

BEGIN_PROP_MAP(CMacMonitor)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("Enabled", DISPID_ENABLED, CLSID_NULL)
	PROP_ENTRY("MonitorEventInterval", dispidMonitorEventInterval, CLSID_NULL)
	PROP_ENTRY("DeviceName", dispidDeviceName, CLSID_NULL)
	PROP_ENTRY("RecvData Event Enabled", dispidRecvDataEnabled, CLSID_NULL)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CMacMonitor)
	CONNECTION_POINT_ENTRY(DIID__IMacCaptureEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CMacMonitor)
	MESSAGE_HANDLER(m_uiReadBuffer, OnReadPakcet)
	MESSAGE_HANDLER(WM_TIMER, OnTimer)
	MESSAGE_HANDLER(m_uiFireNext, OnFireNext)
	CHAIN_MSG_MAP(CComControl<CMacMonitor>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	LRESULT OnReadPakcet(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnTimer(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnFireNext(UINT, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	HRESULT SendOnDataChange( DWORD advf = 0);

	// BOGUS 
	HRESULT IPersistStreamInit_Load(LPSTREAM pStm, ATL_PROPMAP_ENTRY* pMap);

// IDispatch
	STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames,
        LCID lcid, DISPID* rgdispid)
	{
		// IE5 forces this cludge.
		const static LPOLESTR pszAddFilter = L"AddFilter";
		if (wcsicmp(L"AddFilterParam", *rgszNames) == 0)
		{
			return CStockPropImpl<CMacMonitor, IMacMonitor, &IID_IMacMonitor, &LIBID_MACCAPV2Lib>::GetIDsOfNames(riid, &const_cast<LPOLESTR>(pszAddFilter), 1, lcid, rgdispid);
		}
		return CStockPropImpl<CMacMonitor, IMacMonitor, &IID_IMacMonitor, &LIBID_MACCAPV2Lib>::GetIDsOfNames(riid, rgszNames, cNames, lcid, rgdispid);
	}

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IMacMonitor,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (::InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IPerPropertyBrowsing
#if 0
	HRESULT STDMETHODCALLTYPE GetPredefinedStrings( DISPID dispID, CALPOLESTR* pCaStringsOut, CADWORD* pCaCookiesOut );
	HRESULT STDMETHODCALLTYPE GetPredefinedValue( DISPID dispID, DWORD dwCookie, VARIANT* pVarOut );
#endif
// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IMacMonitor
	HRESULT STDMETHODCALLTYPE Start( void);
        
	HRESULT STDMETHODCALLTYPE Stop( void);
        
	HRESULT STDMETHODCALLTYPE RemoveFilters( void);
        
	HRESULT STDMETHODCALLTYPE AddFilter( 
            /* [in] */ IFilterParam __RPC_FAR *pParam);
        
	HRESULT STDMETHODCALLTYPE UnpackHelper( 
            /* [in] */ VARIANT v,
            /* [retval][out] */ BSTR __RPC_FAR *pResult);

	HRESULT STDMETHODCALLTYPE put_RecvDataEnabled( 
            /* [in] */ VARIANT_BOOL NewVal);
        
	HRESULT STDMETHODCALLTYPE get_RecvDataEnabled( 
            /* [retval][out] */ VARIANT_BOOL __RPC_FAR *pRetVal);

	HRESULT STDMETHODCALLTYPE put_MonitorEventInterval( 
            /* [in] */ long NewVal);
        
	HRESULT STDMETHODCALLTYPE get_MonitorEventInterval( 
            /* [retval][out] */ long __RPC_FAR *pRetVal);
        
	HRESULT STDMETHODCALLTYPE put_DeviceName( 
            /* [in] */ BSTR NewValue);
        
	HRESULT STDMETHODCALLTYPE get_DeviceName( 
            /* [retval][out] */ BSTR __RPC_FAR *pResult);

	HRESULT STDMETHODCALLTYPE Clear( void);
			
public:

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		int x = ((rc.right - rc.left) - cxIcon + 1) / 2;
		int y = ((rc.bottom - rc.top) - cyIcon + 1) / 2;

		HICON hIcon = LoadIcon(_Module.GetModuleInstance(), MAKEINTRESOURCE(IDI_MON_ICON));
		DrawIcon(di.hdcDraw, rc.left + x, rc.top + y, hIcon);

		return S_OK;
	}
	BOOL m_bEnabled;
	BOOL m_bValid;
private:
	static unsigned long WINAPI RecvThreadProc(  LPVOID lpParameter  );
	inline bool IsStartRequest(UINT ui) const { return ui == m_uiStartMonitor; }
	inline bool IsStopRequest(UINT ui) const { return ui == m_uiStopMonitor; }
	inline bool IsFreeRequest(UINT ui) const { return ui == m_uiFreeBuffer; }
	inline void SetEvent(HRESULT hr) { m_hResult = hr; ::SetEvent(m_hThreadSync); }
	inline void ResetEvent() { ::ResetEvent(m_hThreadSync); }
	inline void AddTally(long dwSize) { m_lBytes += dwSize; m_lPackets++; }
	HANDLE OpenAdapter();
	HRESULT CreateEventWindow();
	UINT m_uiStartMonitor, m_uiStopMonitor, m_uiFreeBuffer, m_uiReadBuffer, m_uiFireNext;
	bool m_fRecvDataEnabled, m_fDuringCapture;
	bool m_fLoading;
	long m_lMonitorEventInterval;
	CAdapters* m_pAdapters;
	std::wstring m_szDevice;
	std::list<IMacPacket*> m_listPackets;
	HANDLE m_hThread, m_hThreadSync;
	DWORD m_idThread;
	AFilter m_afilter;
	HRESULT m_hResult;
	bool m_fMonitoring;
	long m_lPackets, m_lBytes, m_lLastTick;
};

#endif //__MACMONITOR_H_
